#include "colortableitem.h"

ColorTableItem::ColorTableItem( QTable *table, EditType et, const QString& text, BREAK_TYPE bt) :
QTableItem(table,et,text) 
{ 
    breakType = bt;
}

void ColorTableItem::paint( QPainter *p, const QColorGroup &cg, const QRect &cr, bool selected )
{  
    QColorGroup g( cg );
    if (breakType == NO_BREAK)
        g.setColor( QColorGroup::Base, white);
    else if(breakType == READ_BREAK)
        g.setColor( QColorGroup::Base, yellow);
    else if(breakType == WRITE_BREAK)
        g.setColor( QColorGroup::Base, red);
    QTableItem::paint( p, g, cr, selected );
}

void ColorTableItem::setType(BREAK_TYPE t)
{
    breakType = t;
}

