#include <stdio.h>
#include <ctype.h>
#include <iostream>
#include "hexutils.h"
//#include "./old_files/processor.h"
//#include "./old_files/instruction.h"

struct Instruction_Constructor op_16F84A[] = {

  { 0x3f00,  0x3e00,  ADDLW::construct }, 
  { 0x3f00,  0x3f00,  ADDLW::construct }, // Accomdate don't care bit
  { 0x3f00,  0x0700,  ADDWF::construct },
  { 0x3f00,  0x3900,  ANDLW::construct },
  { 0x3f00,  0x0500,  ANDWF::construct },
  { 0x3c00,  0x1000,  BCF::construct },
  { 0x3c00,  0x1400,  BSF::construct },
  { 0x3c00,  0x1800,  BTFSC::construct },
  { 0x3c00,  0x1c00,  BTFSS::construct },
  { 0x3800,  0x2000,  CALL::construct },
  { 0x3f80,  0x0180,  CLRF::construct },
  { 0x3fff,  0x0103,  CLRW::construct },
  { 0x3fff,  0x0064,  CLRWDT::construct },
  { 0x3f00,  0x0900,  COMF::construct },
  { 0x3f00,  0x0300,  DECF::construct },
  { 0x3f00,  0x0b00,  DECFSZ::construct },
  { 0x3800,  0x2800,  GOTO::construct },
  { 0x3f00,  0x0a00,  INCF::construct },
  { 0x3f00,  0x0f00,  INCFSZ::construct },
  { 0x3f00,  0x3800,  IORLW::construct },
  { 0x3f00,  0x0400,  IORWF::construct },
  { 0x3f00,  0x0800,  MOVF::construct },
  { 0x3f00,  0x3000,  MOVLW::construct },
  { 0x3f00,  0x3100,  MOVLW::construct },
  { 0x3f00,  0x3200,  MOVLW::construct },
  { 0x3f00,  0x3300,  MOVLW::construct },
  { 0x3f80,  0x0080,  MOVWF::construct },
  { 0x3fff,  0x0000,  NOP::construct },
  { 0x3fff,  0x0020,  NOP::construct },
  { 0x3fff,  0x0040,  NOP::construct },
  { 0x3fff,  0x0060,  NOP::construct },
  { 0x3fff,  0x0062,  OPTION::construct },
  { 0x3fff,  0x0009,  RETFIE::construct },
  { 0x3f00,  0x3400,  RETLW::construct },
  { 0x3f00,  0x3500,  RETLW::construct },
  { 0x3f00,  0x3600,  RETLW::construct },
  { 0x3f00,  0x3700,  RETLW::construct },
  { 0x3fff,  0x0008,  RETURN::construct },
  { 0x3f00,  0x0d00,  RLF::construct },
  { 0x3f00,  0x0c00,  RRF::construct },
  { 0x3fff,  0x0063,  SLEEP::construct },
  { 0x3f00,  0x3c00,  SUBLW::construct },
  { 0x3f00,  0x3d00,  SUBLW::construct },
  { 0x3f00,  0x0200,  SUBWF::construct },
  { 0x3fff,  0x0065,  TRIS::construct },
  { 0x3fff,  0x0066,  TRIS::construct },
  { 0x3fff,  0x0067,  TRIS::construct },
  { 0x3f00,  0x0e00,  SWAPF::construct },
  { 0x3f00,  0x3a00,  XORLW::construct },
  { 0x3f00,  0x0600,  XORWF::construct },


};

unsigned char checksum;
const int NUM_OP_16F84A	= sizeof(op_16F84A) / sizeof(op_16F84A[0]);

int
getachar (FILE * file)
{
  int c;

  do
    c = fgetc (file);
  while (c == '\r');		/* strip LF out of MSDOS files */

  return c;
}

unsigned char 
getbyte (FILE * file)
{
  unsigned char byte;
  unsigned int data;

  fscanf (file, "%02x", &data);

  byte = data & 0xff;
  checksum += byte;		/* all the bytes are used in the checksum */
  /* so here is the best place to update it */
  return byte;
}

unsigned int
getword(FILE *file)
{
  unsigned char lo = getbyte(file);
  return ((getbyte(file) << 8) | lo);
}

int
readihex16 (Processor *cpu, FILE * file)
{
  int address;
  int linetype = 0;
  int wordsthisline;
  int i;
  int lineCount = 1;
  int csby;
  unsigned char hi, lo;

  while (1)
    {
      if (getachar (file) != ':')
	{
	  printf ("Need a colon as first character in each line\n");
	  printf ("Colon missing in line %d\n", lineCount);
	  //exit (1);
	  return 1;
	}

      checksum = 0;

      wordsthisline = getbyte (file) / 2;
      hi = getbyte (file);
      lo = getbyte (file);
      address = (hi << 8 | lo) / 2;

      /* wierdness of INHX16! address different */
      /* endian-ness and 2x too big */

      linetype = getbyte (file);	/* 0 for data, 1 for end  */

      if (linetype == 1)	/* lets get out of here hit the end */
	break;

      if (0 == linetype) {	// data record
	  for (i = 0; i < wordsthisline; i++)
	      cpu->init_program_memory(address++, getword(file));
      } else if (4 == linetype) {	// Extended linear address
	  unsigned char b1, b2;
	  b1 = getbyte (file);		// not sure what these mean
	  b2 = getbyte (file);

	  if ((0 != address) || (0 != b1) || (0 != b2)) {
	      printf ("Error! Unhandled Extended linear address! %x %.2x%.2x\n",
		      address, b1, b2);
	      break;
	  }
	  // Should do something with all this info
	  // BUG: must fix this for pic18 support
      } else {
	  printf ("Error! Unknown record type! %d\n", linetype);
	  break;
      }

      csby = getbyte (file);	/* get the checksum byte */
      /* this should make the checksum zero */
      /* due to side effect of getbyte */

      if (checksum)
	{
	  printf ("Checksum error in input file.\n");
	  printf ("Got 0x%02x want 0x%02x at line %d\n", csby, (0 - checksum) & 0xff, lineCount);
	  return 1;
	}

      (void) getachar (file);	/* lose <return> */

      lineCount++;
    }

  return 0;
}

Instruction* disasm(Processor *cpu,unsigned int inst)
{
   Instruction *pi = NULL;
   unsigned int opcode, inst_mask;
   
   for(int i=0;i<NUM_OP_16F84A;i++)
   {
      opcode = op_16F84A[i].opcode;
      inst_mask = op_16F84A[i].inst_mask;
      //std::cout<<"HELLO"<<std::endl;
      
      if((inst_mask & inst) == opcode)
         pi = op_16F84A[i].inst_constructor(cpu, inst);
   }

   if(pi == NULL)
    pi = Invalid_Instruction::construct(cpu, inst);
    
   return (pi);
}
