/****************************************************************************
** ui.h extension file, included from the uic-generated form implementation.
**
** If you want to add, delete, or rename functions or slots, use
** Qt Designer to update this file, preserving your code.
**
** You should not define a constructor or destructor in this file.
** Instead, write your code in functions called init() and destroy().
** These will automatically be called by the form's constructor and
** destructor.
*****************************************************************************/
#include <typeinfo>

/* Initiates file open action */
void MicroSim::fileOpen()
{
    // Determine whether to show open file dialog
    if(showOpen)
 openFile = QFileDialog::getOpenFileName(QDir("./").absPath(),
      "COD files (*.cod);;Binary files (*.bin);;Hex files (*.hex);;All files (*.*)",     
      this,"Open File Dialog","Choose a file to load");
    
    // File has been selected to open
    if(openFile != NULL)
    {
 if(file_is_loaded == false)
     file_is_loaded = true;
	else if(!showOpen || file_is_loaded)
	{
	    // If hex file opened then no assembly source is shown
	    if(openFile.endsWith(".hex"))
	    {
		removeSourcePages();
		srcTabWidget->addTab(new QTextBrowser,"Untitled");
		srcTabWidget_2->addTab(new QTextBrowser,"Untitled");
	    }
	}
	
	// Removes the source code pages for the new file
	if(srcPages != NULL && srcPages_2 != NULL)
	{
	    for(int i=0;i<cpu->number_of_source_files;i++)
	    {
		if(srcPages[i] != NULL)
		    delete srcPages[i];
		if(srcPages_2[i] != NULL)
		    delete srcPages_2[i];
	    }
	    delete srcPages;
	    delete srcPages_2;
	    srcPages = NULL;
	    srcPages_2 = NULL;
	}         
	interface->open(openFile.ascii());
	opListView->clear();
	opListView_2->clear();
	historyListView->clear();
 historyListView_2->clear();
 loadOpcodeList(opListView);
 loadOpcodeList(opListView_2);
 loadW_Status_PC();
 viewRegValues();
 viewRegValues_2();
 
 // If file is COD then open the new source
 if(openFile.endsWith(".cod") || openFile.endsWith(".COD"))
     NewSource();
 
 // Cause a device reset and clear all breahpoints
 clearAllBP(); 
 cpu->reset(POR_RESET);
 
 
 // Pin configuration dialog
 pinDialog->exec();      
 pinDialog->set_io_config();
 if(cpu->hm->getWriteMode() == 0)
     gbMapper->setTitle("Mapper (Not using IO!)");
 if(cpu->hm->getWriteMode() == 1)
     gbMapper->setTitle("Mapper (0-13 Inputs / 0-4 Outputs)");
 if(cpu->hm->getWriteMode() == 2)
     gbMapper->setTitle("Mapper (0-5 Inputs / 0-12 Outputs)");  
 QStringList stringList;
	if(cpu->hm->getWriteMode() == 1)
	{
	    stringList.append("X");
	    stringList.append("1 (Out)");
	    stringList.append("2 (In)");
	    stringList.append("3 (In)");
	    stringList.append("4 (In)");
	    stringList.append("5 (In)");
	    stringList.append("6 (In)");
	    stringList.append("7 (In)");
	    stringList.append("8 (In)");
	    stringList.append("9 (In)");
	    stringList.append("10 (In)");
	    stringList.append("11 (In)");
	    stringList.append("12 (In)");
	    stringList.append("13 (In)");
	    stringList.append("14 (Out)");
	    stringList.append("15 (In)");
	    stringList.append("16 (Out)");
	    stringList.append("17 (Out)");
	    
	}
	else if(cpu->hm->getWriteMode() == 2)
	{
	    stringList.append("X");
	    stringList.append("1 (Out)");
	    stringList.append("2 (Out)");
	    stringList.append("3 (Out)");
	    stringList.append("4 (Out)");
	    stringList.append("5 (Out)");
	    stringList.append("6 (Out)");
	    stringList.append("7 (Out)");
	    stringList.append("8 (Out)");
	    stringList.append("9 (Out)");
	    stringList.append("10 (In)");
	    stringList.append("11 (In)");
	    stringList.append("12 (In)");
	    stringList.append("13 (In)");
	    stringList.append("14 (Out)");
	    stringList.append("15 (In)");
	    stringList.append("16 (Out)");
	    stringList.append("17 (Out)");
	    
	}
	else
	{
	    stringList.append("X");
	}  
	for(int i=0;i<19;i++)
	{
	    if(comboArray[i] != NULL)
	    {
		comboArray[i]->clear();
		comboArray[i]->insertStringList(stringList);
	    }
	}     
    }
    
    showOpen=true;
}

// Removes all source pages in the Source Browser
void MicroSim::removeSourcePages()
{
    for(int i=0;i<srcTabWidget->count();i++)
    {
	srcTabWidget->removePage(srcTabWidget->page(i));        
	srcTabWidget_2->removePage(srcTabWidget_2->page(i));
    }
}

// Gathers all the source files to be displayed and loads them into memory
void MicroSim::NewSource()
{
    int i;
    char *file_name;
    struct file_context *file;
    int file_id;
    
    removeSourcePages();
    srcPages = new QListView*[cpu->number_of_source_files];
    srcPages_2 = new QListView*[cpu->number_of_source_files];
    
    for(i=0;i<cpu->number_of_source_files;i++)
    {
	file = interface->get_file_context(i);
	file_name = file->name;
	QString filename_str(file_name);
	
	if(strcmp(file_name+strlen(file_name)-4,".lst")
	    &&strcmp(file_name+strlen(file_name)-4,".LST")
	    &&strcmp(file_name+strlen(file_name)-4,".cod")
	    &&strcmp(file_name+strlen(file_name)-4,".COD"))
	    {        
	    srcPages[i] = new QListView;
	    srcPages_2[i] = new QListView;
	    srcPages[i]->setAllColumnsShowFocus(true);
	    srcPages_2[i]->setAllColumnsShowFocus(true);
	    srcTabWidget->insertTab(srcPages[i],filename_str,i);
	    srcTabWidget_2->insertTab(srcPages_2[i],filename_str,i);
	    
	    if(!strcmp(file_name+strlen(file_name)-2,".c")
		||!strcmp(file_name+strlen(file_name)-2,".C")
		||!strcmp(file_name+strlen(file_name)-4,".jal")
		||!strcmp(file_name+strlen(file_name)-4,".JAL") )
		{
		// These are HLL sources
		//file_id_to_source_mode[i]=ProgramMemoryAccess::HLL_MODE;
		cpu->pma.set_hll_mode(ProgramMemoryAccess::HLL_MODE);
	    }
	    
	    // FIXME, gpsim may change sometime making this fail
	    file_id = i;
	    
	    // Make sure that the file is open
	    if(file->file_ptr == NULL)
	    {
		if(file_name != NULL)
		    file->file_ptr = fopen_path(file_name,"r");
		
		if(file->file_ptr == NULL)
		{
		    printf("file \"%s\" not found\n",file_name);
		    continue;
		}
	    }
	    
	    rewind(file->file_ptr);
	    if(strcmp(file_name+strlen(file_name)-4,".asm") == 0||
	       strcmp(file_name+strlen(file_name)-4,".ASM") == 0)
	    {
		loadSourceFile(file->file_ptr,i);
		connect(srcPages[i],SIGNAL(doubleClicked(QListViewItem*,const QPoint &, int)),this,SLOT(srcPageListClick(QListViewItem*,const QPoint &, int)));
		connect(srcPages_2[i],SIGNAL(doubleClicked(QListViewItem*,const QPoint &, int)),this,SLOT(srcPageListClick(QListViewItem*,const QPoint &, int)));
	    }
	    else
		loadHeaderFile(file->file_ptr,i);
	}
	else
	{
	    srcPages[i] = NULL;
	    srcPages_2[i] = NULL;
	}
    }
    srcTabWidget->showPage(srcTabWidget->page(0));
    srcTabWidget_2->showPage(srcTabWidget_2->page(0));
    menuNextAction->setDisabled(false);
    menuOverAction->setDisabled(false);
    menuRunAction->setDisabled(false);
    
}

// Slot to handle setting breakpoints in the Source Browser
void MicroSim::srcPageListClick(QListViewItem* item,const QPoint &point, int n)
{
    int line = (item->itemPos() / 18)+1;
    interface->toggle_break_at_line(srcTabWidget->currentPageIndex(),line);
    int newLine = interface->get_src_line(interface->find_closest_address_to_line(srcTabWidget->currentPageIndex(),line));
    
    QListViewItem* newItem = srcPages[srcTabWidget->currentPageIndex()]->firstChild();
    for(int i=1;i<newLine;i++)
	newItem = newItem->nextSibling();
    
    if(newItem->text(0) == "X")
	newItem->setText(0,"");
    else
	newItem->setText(0,"X");
    newItem->setSelected(false);
    newItem->repaint();
    
    newItem = srcPages_2[srcTabWidget_2->currentPageIndex()]->firstChild();
    for(int i=1;i<newLine;i++)
	newItem = newItem->nextSibling();
    
    if(newItem->text(0) == "X")
	newItem->setText(0,"");
    else
	newItem->setText(0,"X");
    newItem->setSelected(false);
    newItem->repaint();
}

// Loads the source code into the QListViews
void MicroSim::loadSourceFile(FILE *fp, int i)
{
    char buffer[256];
    srcPages[i]->clear();    
    srcPages[i]->addColumn("BP");
    srcPages[i]->addColumn("");
    srcPages[i]->setColumnWidth(0,26);
    srcPages[i]->setColumnWidth(1,680);
    srcPages[i]->setSorting(-1);
    srcPages_2[i]->clear();
    srcPages_2[i]->addColumn("BP");
    srcPages_2[i]->addColumn("");
    srcPages_2[i]->setColumnWidth(0,26);
    srcPages_2[i]->setColumnWidth(1,300);
    srcPages_2[i]->setSorting(-1);
    
    
    QListViewItem *tempItem, *tempItem2;
    fgets(buffer,256,fp);
    QString str(buffer);
    QListViewItem *listItem = new QListViewItem(srcPages[i],"",str);
    QListViewItem *listItem2 = new QListViewItem(srcPages_2[i],"",str);
    
    while(fgets(buffer,256,fp)!=NULL)
    {
	QString str(buffer);
	tempItem = new QListViewItem(srcPages[i],listItem,"",str);        
	listItem = tempItem;
	tempItem2 = new QListViewItem(srcPages_2[i],listItem2,"",str);        
	listItem2 = tempItem2;
    }
}

//Loads the header file into QListViews
void MicroSim::loadHeaderFile(FILE *fp, int i)
{
    char buffer[256];
    srcPages[i]->clear();
    srcPages[i]->addColumn("");
    srcPages[i]->setColumnWidth(0,705);
    srcPages[i]->setSorting(-1);
    srcPages_2[i]->clear();
    srcPages_2[i]->addColumn("");
    srcPages_2[i]->setColumnWidth(0,455);
    srcPages_2[i]->setSorting(-1);
    
    QListViewItem *tempItem, *tempItem2;
    fgets(buffer,256,fp);
    QString str(buffer);
    QListViewItem *listItem = new QListViewItem(srcPages[i],str);
    QListViewItem *listItem2 = new QListViewItem(srcPages_2[i],str);
    
    while(fgets(buffer,256,fp)!=NULL)
    {
	listItem->setSelectable(false);
	listItem2->setSelectable(false);
	QString str(buffer);
	tempItem = new QListViewItem(srcPages[i],listItem,str);
	listItem = tempItem; 
	tempItem2 = new QListViewItem(srcPages_2[i],listItem2,str);
	listItem2 = tempItem2; 
    }
}

// Allows the user to save their defined pin mapping to a file
void MicroSim::saveMappingFile()
{
    // Remember to check if file exists and ask to overwrite I can't be buggered right now
    QString saveFile = QFileDialog::getSaveFileName(QDir("./").absPath(),
						    "MicroSim Pin Mapping (*.msm)",
						    this,"Save Pin Mapping",
						    "Choose a file to save");
    if(saveFile != NULL)
    {
	ofstream mapFile(saveFile.local8Bit(), ios_base::out);
	if(mapFile.fail())
	{
	    QString msg = "Could not save file "+saveFile;
	    QMessageBox::critical(this, "File Saving Error", 
				  msg, 
				  QMessageBox::Ok, QMessageBox::NoButton, 
				  QMessageBox::NoButton);
	    return;
	}
	
	for(int i=1;i<=18;i++)
	{
	    int temp = cpu->hm->getPortPin(i);
	    cout<<"i: "<<temp<<endl;
	    mapFile<<i<<":"<<cpu->hm->getPortPin(i)<<endl;
	}
	mapFile.close();      
    }
}

// Allows the user to load a previously saved pin mapping file
void MicroSim::loadMappingFile()
{
    QString loadFile = QFileDialog::getOpenFileName(QDir("./").absPath(),
						    "MicroSim Pin Mapping (*.msm)",     
						    this,"Open File Dialog","Choose a file to load");
    if(loadFile != NULL)
    {
	ifstream mapFile(loadFile.local8Bit(),ios_base::in);
	if(mapFile.fail())
	{
	    QString msg = "Could not save file "+loadFile;
	    QMessageBox::critical(this, "File Saving Error", 
				  msg, 
				  QMessageBox::Ok, QMessageBox::NoButton, 
				  QMessageBox::NoButton);
	    return;
	}
	
	char delim;
	int picPin, portPin;
	cout<<dec;
	
	while(!mapFile.eof())
	{
	    mapFile>>picPin>>delim>>portPin;
	    if(portPin!=-1)
		cpu->hm->mapPin(picPin,portPin);
	}
	mapFile.close();
	int temp;
	for(int i=1;i<=18;i++)
	{
	    temp = cpu->hm->getPortPin(i);
	    if(temp == -1)
		temp = 0;
	    if(comboArray[i] != NULL)
		comboArray[i]->setCurrentItem(temp); 
	}
 updatePinLabels();
 
    }
    
}

void MicroSim::fileExit()
{
    exit(EXIT_SUCCESS);
}

void MicroSim::helpContents()
{
    
    helpBrowser->showMaximized();
}

void MicroSim::helpAbout()
{    
    aboutDialog->show();
}

void MicroSim::init()
{   
    //set priority to highest possible
    int pid = getpid();
    setpriority(PRIO_PROCESS, pid, -15);
    // Create all required objects
    cpu = new Processor(this);
    cpu->create();
    interface = new Interface(cpu);
    aboutDialog = new AboutDialog(this);
    pinDialog = new PinDialog(this);
    pinDialog->setCPU(cpu);
    QString home;
    home = QDir(APPSDIR "documentation/index.htm").absPath();
    helpBrowser = new HelpBrowser(home, "./", 0, "help viewer");
    
    //thread = new MyThread(cpu);
    file_is_loaded = false;
    // Timer to regularly check for program execution aborts
    timer = new QTimer(this);
    connect(timer,SIGNAL(timeout()),this,SLOT(programAlert()));
    timer->start(50);
    instBuffCount = 0;
    
    // Timer to perform run at 5000 instructions per 1 ms
    runTimer = new QTimer(this);
    connect(runTimer,SIGNAL(timeout()),this,SLOT(startProcessor()));
    
    srcTabWidget->setMargin(5);
    srcTabWidget->removePage(srcTabWidget->page(0));
    srcTabWidget->addTab(new QTextBrowser,"Untitled");
    srcTabWidget_2->setMargin(5);
    srcTabWidget_2->removePage(srcTabWidget_2->page(0));
    srcTabWidget_2->addTab(new QTextBrowser,"Untitled");
    srcPages = NULL;
    srcPages_2 = NULL;
    
    setupRegColors();
    
    // Setup the other GUI views
    setupHistoryList(historyListView);
    setupWatchView(watchView);
    setupRegView(regViewTable); 
    setupOpcodeList(opListView);
    
    // Sets up radio button groups
    radioGroup1 = new QButtonGroup();
    radioGroup1->insert(radioButtonProg,0);
    radioGroup1->insert(radioButtonRAM,1);
    radioGroup1->insert(radioButtonEEPROM,2);
    radioButtonRAM->setChecked(true);
    connect(radioGroup1,SIGNAL(clicked(int)),this,SLOT(updateRegView(int)));
    
    // Sets the parallel port radio button groups
    radioGroup3 = new QButtonGroup();
    radioGroup3->insert(rbParallelPort1,0);
    radioGroup3->insert(rbParallelPort2,1);
    radioGroup3->insert(rbParallelPort3,2);
    rbParallelPort2->setChecked(true);
    radioGroup3->setRadioButtonExclusive(true);
    connect(radioGroup3,SIGNAL(clicked(int)),this,SLOT(updateParallelPortAddress(int)));
    // Initially set Parallel Port address to LPT1 in HardwareMapper
    updateParallelPortAddress(1);
    
    // Connects viewNames checkbox signal to slot viewRegNames()
    connect(viewNames,SIGNAL(toggled(bool)),this,SLOT(viewRegNames(bool)));
    
    // Sets up the Workspace Tab
    setupAllTab();
    
    comboArray[0] = NULL;
    comboArray[1] = comboBox1;
    comboArray[2] = comboBox2;
    comboArray[3] = comboBox3;
    comboArray[4] = NULL;
    comboArray[5] = NULL;
    comboArray[6] = comboBox6;
    comboArray[7] = comboBox7;
    comboArray[8] = comboBox8;
    comboArray[9] = comboBox9;
    comboArray[10] = comboBox10;
    comboArray[11] = comboBox11;
    comboArray[12] = comboBox12;
    comboArray[13] = comboBox13;
    comboArray[14] = NULL;
    comboArray[15] = NULL;
    comboArray[16] = NULL;
    comboArray[17] = comboBox17;
    comboArray[18] = comboBox18;
    
    int temp;
    for(int i=0;i<=18;i++)
    {
 if(comboArray[i] != NULL)
 {
     temp = (cpu->hm->getPortPin(i)==-1) ? 0 : cpu->hm->getPortPin(i); 
     comboArray[i]->setCurrentItem(temp);
 }
    }
    
    updatePinLabels();
    
    // Connects all combo boxes to slot updatePinLabels()
    connect(comboBox1,SIGNAL(activated(int)),this,SLOT(changeCombo1()));
    connect(comboBox2,SIGNAL(activated(int)),this,SLOT(changeCombo2()));
    connect(comboBox3,SIGNAL(activated(int)),this,SLOT(changeCombo3()));
    connect(comboBox6,SIGNAL(activated(int)),this,SLOT(changeCombo6()));
    connect(comboBox7,SIGNAL(activated(int)),this,SLOT(changeCombo7()));
    connect(comboBox8,SIGNAL(activated(int)),this,SLOT(changeCombo8()));
    connect(comboBox9,SIGNAL(activated(int)),this,SLOT(changeCombo9()));
    connect(comboBox10,SIGNAL(activated(int)),this,SLOT(changeCombo10()));
    connect(comboBox11,SIGNAL(activated(int)),this,SLOT(changeCombo11()));
    connect(comboBox12,SIGNAL(activated(int)),this,SLOT(changeCombo12()));
    connect(comboBox13,SIGNAL(activated(int)),this,SLOT(changeCombo13()));
    connect(comboBox17,SIGNAL(activated(int)),this,SLOT(changeCombo17()));
    connect(comboBox18,SIGNAL(activated(int)),this,SLOT(changeCombo18()));
 
    freqCombo->setCurrentItem(2);
    instructionRate = 1000;
    connect(freqCombo,SIGNAL(activated(int)),this,SLOT(setOpFreq(int)));
    
    showOpen = true;
    
    // disables certain menu actions
    menuStopAction->setDisabled(true);
    menuNextAction->setDisabled(true);
    menuOverAction->setDisabled(true);
    menuRunAction->setDisabled(true);
}

// Sets up the widgets in the Workspace Tab
void MicroSim::setupAllTab()
{
    setupHistoryList(historyListView_2);
    setupWatchView(watchView_2);
    setupRegView(regViewTable_2);
    setupOpcodeList(opListView_2);
    
    // Sets up radio button groups
    radioGroup2 = new QButtonGroup();
    radioGroup2->insert(radioButtonProg_2,3);
    radioGroup2->insert(radioButtonRAM_2,4);
    radioGroup2->insert(radioButtonEEPROM_2,5);   
    radioButtonRAM_2->setChecked(true);
    connect(radioGroup2,SIGNAL(clicked(int)),this,SLOT(updateRegView(int)));
    
    // Connects viewNames2 checkbox signal to slot viewRegNames2()
    connect(viewNames_2,SIGNAL(toggled(bool)),this,SLOT(viewRegNames_2(bool)));
}

void MicroSim::loadW_Status_PC()
{
    // Place values in Status, W and PC fields
    QString buf;
    buf.sprintf("0x%02x",interface->get_status());
    leStatus->setText(buf);
    leStatus_2->setText(buf);
    buf.sprintf("0x%02x",interface->get_w());
    leWReg->setText(buf);
    leWReg_2->setText(buf);
    buf.sprintf("0x%04x",interface->get_pc());
    lePC->setText(buf);
    lePC_2->setText(buf); 
}

// When user selects a register cell, they should be able to then edit.
void MicroSim::regSelected()
{
    int row = regViewTable->currentRow();
    int col = regViewTable->currentColumn();
    QHeader* columnHeader = regViewTable->horizontalHeader();
    QHeader* rowHeader = regViewTable->verticalHeader();
    int addr = (rowHeader->label(row)).toInt(0,16) + (columnHeader->label(col)).toInt(0,16);
    QString regAddr = QString::number(addr,16);
    if(addr < 16)
	regAddr = "Register[  0"+regAddr.upper()+"  ]:";
    else
	regAddr = "Register[  "+regAddr.upper()+"  ]:";
    
    if(col < 16)
    {
	regEditLabel->setText(regAddr);
	leRegEdit->setText(regViewTable->text(row,col));
	leRegEdit->setFocus();
    }
    else
    {
	regEditLabel->setText("Register[      ]:");
	leRegEdit->setText("");
    }
}

// Register has been edited
void MicroSim::regEdited()
{
    // Need error checking here
    QString newVal = leRegEdit->text();
    leRegEdit_2->setText(newVal);
    newVal = newVal.stripWhiteSpace();
    int row = regViewTable->currentRow();
    int col = regViewTable->currentColumn();
    QString addr = regEditLabel->text();
    addr = addr.remove("Register[  ");
    addr.truncate(2);
    bool ok;
    if(col < 16)
    {
 regViewTable->setText(row,col,newVal);
 regViewTable_2->setText(row,col,newVal);
 if(radioGroup1->selectedId() == 0)
     interface->put_opcode(addr.toInt(&ok,16),newVal.toInt(&ok,16));
 else if(radioGroup1->selectedId() == 1)
     interface->put_register_value(REGISTER_RAM,addr.toInt(&ok,16),newVal.toInt(&ok,16));
 else if(radioGroup1->selectedId() == 2)
     interface->put_register_value(REGISTER_EEPROM,addr.toInt(&ok,16),newVal.toInt(&ok,16));
 
    }
}

// When user selects a register in the Workspace Source Browser view
void MicroSim::regSelected_2()
{
    int row = regViewTable_2->currentRow();
    int col = regViewTable_2->currentColumn();
    QHeader* columnHeader = regViewTable_2->horizontalHeader();
    QHeader* rowHeader = regViewTable_2->verticalHeader();
    int addr = (rowHeader->label(row)).toInt(0,16) + (columnHeader->label(col)).toInt(0,16);
    QString regAddr = QString::number(addr,16);
    if(addr < 16)
	regAddr = "Register[  0"+regAddr.upper()+"  ]:";
    else
	regAddr = "Register[  "+regAddr.upper()+"  ]:";
    
    if(col < 16)
    {
	regEditLabel_2->setText(regAddr);
	leRegEdit_2->setText(regViewTable_2->text(row,col));
	leRegEdit_2->setFocus();
    }
    else
    {
	regEditLabel_2->setText("Register[      ]:");
	leRegEdit_2->setText("");
    }
}

void MicroSim::regEdited_2()
{
    // Need error checking here
    QString newVal = leRegEdit_2->text();
    leRegEdit->setText(newVal);
    newVal = newVal.stripWhiteSpace();
    int row = regViewTable_2->currentRow();
    int col = regViewTable_2->currentColumn();
    //QString val = newVal.section("x",1,1);
    QString addr = regEditLabel_2->text();
    addr = addr.remove("Register[  ");
    addr.truncate(2);
    //cout<<"Value: "<<s.ascii()<<endl;
    //cout<<"Addr: "<<addr.ascii()<<endl;
    bool ok;
    if(col < 16)
    {
	regViewTable->setText(row,col,newVal);
	regViewTable_2->setText(row,col,newVal);
	if(radioGroup2->selectedId() == 3)
	    interface->put_opcode(addr.toInt(&ok,16),newVal.toInt(&ok,16)); 
	else if(radioGroup2->selectedId() == 4)
	    interface->put_register_value(REGISTER_RAM,addr.toInt(&ok,16),newVal.toInt(&ok,16));
	else if(radioGroup2->selectedId() == 5)
	    interface->put_register_value(REGISTER_EEPROM,addr.toInt(&ok,16),newVal.toInt(&ok,16));
 
    }
}

void MicroSim::setupHistoryList( QListView * listView )
{
    /* Sets up the history list */
    QListViewItem *first = listView->firstChild();
    listView->takeItem(first);
    listView->addColumn("Instruction");
    listView->setColumnText(0,"No.");
    if(listView == historyListView_2)
 listView->setColumnWidth(0,40);
    
}

// Adds items to the history list. Takes a QListView and instruction name
// as parameters.
void MicroSim::addToHistoryList(QListView * listView,const char* instruction)
{
    QString inst(instruction);
    QListViewItem *lastItem = listView->lastItem();
    QListViewItem *item;
    if(lastItem == NULL)
	item = new QListViewItem(listView,QString::number(1),inst);    
    else
	item = new QListViewItem(listView,lastItem,QString::number(listView->childCount()+1),inst); 
    listView->ensureItemVisible(item);
    listView->setSorting(-1);
}

// Updates the History Lists 
void MicroSim::updateHistoryLists()
{
    clearHistoryLists();
    for(int i=0;i<instBuffCount;i++)
    {
 addToHistoryList(historyListView,instructionBuffer[i]);
 addToHistoryList(historyListView_2,instructionBuffer[i]);
    }
}

// Clears the history list
void MicroSim::clearHistoryLists()
{
    historyListView->clear();
    historyListView_2->clear();
}

// Sets up the columns and widthts of the Opcode Lists
void MicroSim::setupOpcodeList( QListView * listView )
{
    /* Sets up the opcode list */
    listView->clear();
    listView->setColumnText(0,"Address");
    if(listView == opListView)
    {
 listView->setColumnWidth(0,100);
 listView->addColumn("Opcode",100);
 listView->addColumn("Instruction",255);
    }
    else
    {
 opListView_2->setColumnWidth(0,60);
 opListView_2->addColumn("Opcode",60);
 opListView_2->addColumn("Instruction",135);
    }
    listView->setSorting(-1);
}

// Traverses the program memory to populate the Opcode List
void MicroSim::loadOpcodeList(QListView * listView)
{
    QListViewItem* tempItem;
    unsigned int i = 0;
    QString addr;
    QString opcode;
    char buf[128];
    QString name(interface->get_opcode_name(i,buf));
    addr.sprintf("0x%04x",i);
    opcode.sprintf("0x%04x",interface->get_opcode(i));
    QListViewItem* listItem = new QListViewItem(listView,addr,opcode,name);
    listItem->setSelected(true);
    for(i++;i<interface->get_program_memory_size();i++)
    {
 name = interface->get_opcode_name(i,buf);
 addr.sprintf("%04x",i);
 addr = "0x"+addr;
 opcode.sprintf("%04x",interface->get_opcode(i));
 opcode = "0x"+opcode;
 tempItem = new QListViewItem(listView,listItem,addr,opcode,name);
 listItem = tempItem;
    }
}

// Sets up the columns and widths of the Watch Viewer
void MicroSim::setupWatchView( QListView * listView )
{
    // Sets up watch viewer
    QListViewItem* first = listView->firstChild();
    listView->takeItem(first);
    listView->setColumnText(0,"Name");
    listView->setColumnWidth(0,50);
    listView->addColumn("BP?",50);
    listView->addColumn("Type",50);
    listView->addColumn("Address",55);
    listView->addColumn("Dec",40);
    listView->addColumn("Hex",40);
    listView->addColumn("Ascii",40);
    listView->addColumn("Binary",150);
    listView->setSorting(-1);
    connect(listView,SIGNAL(doubleClicked(QListViewItem*,const QPoint&,int)),
	    this,SLOT(removeWatchReg(QListViewItem*,const QPoint&,int)));
}

// When the user edits the PC field
void MicroSim::PCEdited()
{
    QString pcStr;
    pcStr.sprintf("0x%04x",interface->get_pc());
    QListViewItem* item = opListView->findItem(pcStr,0);
    QListViewItem* item2 = opListView_2->findItem(pcStr,0);
    if(item != NULL && item2 != NULL)
    {
	item->setSelected(false);
	item->repaint();
	item2->setSelected(false);
	item2->repaint();
    }
    updateSrcPages(false);
    
    lePC_2->setText(lePC->text());
    QString val = lePC->text();
    bool ok;
    interface->put_pc_value(val.toInt(&ok,16));
    
    pcStr.sprintf("0x%04x",interface->get_pc());
    item = opListView->findItem(pcStr,0);
    item2 = opListView_2->findItem(pcStr,0);
    if(item != NULL && item2 != NULL)
    {
	item->setSelected(true);
	item->repaint();
	item2->setSelected(true);
	item2->repaint();
	opListView->ensureItemVisible(item);
	opListView_2->ensureItemVisible(item2);
    }
    
    updateSrcPages(true);
    
}

// When the user edits the PC field in the Workspace Tab
void MicroSim::PCEdited_2()
{
    QString pcStr;
    pcStr.sprintf("0x%04x",interface->get_pc());
    QListViewItem* item = opListView->findItem(pcStr,0);
    QListViewItem* item2 = opListView_2->findItem(pcStr,0);
    if(item != NULL && item2 != NULL)
    {
	item->setSelected(false);
	item->repaint();
	item2->setSelected(false);
	item2->repaint();
    }
    updateSrcPages(false);
    
    lePC->setText(lePC_2->text());
    QString val = lePC_2->text();
    bool ok;
    interface->put_pc_value(val.toInt(&ok,16));
    
    pcStr.sprintf("0x%04x",interface->get_pc());updateWatchViewer(watchView);
    updateWatchViewer(watchView_2);
    item = opListView->findItem(pcStr,0);
    item2 = opListView_2->findItem(pcStr,0);
    if(item != NULL && item2 != NULL)
    {
 item->setSelected(true);
 item->repaint();
 item2->setSelected(true);
 item2->repaint();
 opListView->ensureItemVisible(item);
 opListView_2->ensureItemVisible(item2);
    }
    
    updateSrcPages(true);
}

// User edits the W Register via the Register Viewer
void MicroSim::WEdited()
{
    leWReg_2->setText(leWReg->text());
    QString val = leWReg->text();
    bool ok;
    interface->put_w(val.toInt(&ok,16));
}

// User edits the W Register via the Register Viewer from the Workspace Tab
void MicroSim::WEdited_2()
{
    leWReg->setText(leWReg_2->text());
    QString val = leWReg_2->text();
    bool ok;
    interface->put_w(val.toInt(&ok,16));
}

// User edits the Status register 
void MicroSim::StatusEdited()
{
    leStatus_2->setText(leStatus->text());
    QString val = leStatus->text();
    bool ok;
    interface->put_status(val.toInt(&ok,16));
}

// User edits the Status register from the Workspace Tab
void MicroSim::StatusEdited_2()
{
    leStatus->setText(leStatus_2->text());
    QString val = leStatus_2->text();
    bool ok;
    interface->put_status(val.toInt(&ok,16));
}

void MicroSim::setupRegView( QTable * table )
{
    /* Formats Register Viewer table to be visible in main window width */
    for(int i=0;i<16;i++)
 table->setColumnWidth(i,60);
    table->setColumnWidth(16,145);
    for(int i=0;i<16;i++)
 table->setRowHeight(i,24);
    table->setReadOnly(true);
    
    QString register_value;
    int j=0;
    for(unsigned int i=0;i<interface->get_register_memory_size(REGISTER_RAM);i++)
    {
	if( (i%16 == 0) && (i!=0) )
	    j++;
	register_value.sprintf("0x%02x",interface->get_register_value(REGISTER_RAM,i));
	table->setText(j,i%16,register_value.ascii());
    }
    
    if(table==regViewTable)
    {
	connect(regViewTable,SIGNAL(selectionChanged()),this,SLOT(regSelected()));
 connect(leRegEdit,SIGNAL(returnPressed()),this,SLOT(regEdited()));
 connect(lePC,SIGNAL(returnPressed()),this,SLOT(PCEdited()));
 connect(leWReg,SIGNAL(returnPressed()),this,SLOT(WEdited()));
 connect(leStatus,SIGNAL(returnPressed()),this,SLOT(StatusEdited()));
 connect(regViewTable,SIGNAL(clicked(int,int,int,const QPoint&)),this,SLOT(watchRegister(int,int,int,const QPoint&)));
 radioButtonRAM->setChecked(true);
    }
    else
    {
 connect(regViewTable_2,SIGNAL(selectionChanged()),this,SLOT(regSelected_2()));
 connect(leRegEdit_2,SIGNAL(returnPressed()),this,SLOT(regEdited_2()));
 connect(lePC_2,SIGNAL(returnPressed()),this,SLOT(PCEdited_2()));
 connect(leWReg_2,SIGNAL(returnPressed()),this,SLOT(WEdited_2()));
 connect(leStatus_2,SIGNAL(returnPressed()),this,SLOT(StatusEdited_2()));
 connect(regViewTable_2,SIGNAL(clicked(int,int,int,const QPoint&)),this,SLOT(watchRegister_2(int,int,int,const QPoint&)));
 radioButtonRAM_2->setChecked(true);
    }
    
}

void MicroSim::viewRegValues()
{
    QString register_value;
    QString asciiVal;
    unsigned int iter = 0;  
    
    for(int i=0;i<regViewTable->numRows();i++)
    {
 for(int j=0;j<regViewTable->numCols();j++)
 {
     if( (j%16 == 0) && (j != 0) )
     {
  regViewTable->setText(i,j,asciiVal);
  asciiVal = "";
     }
     else
     {
  register_value.sprintf("0x%02x",interface->get_register_value(REGISTER_RAM,iter));
  regViewTable->setText(i,j,register_value.ascii());
  char c = (char)interface->get_register_value(REGISTER_RAM,iter++);
  if( (c < ' ') || (c >'z'))
      asciiVal.append('.');
  else
      asciiVal.append(c);
     }
     
     if(iter == interface->get_register_memory_size(REGISTER_RAM))
	    {
		regViewTable->setText(i,j+1,asciiVal);
		break;
	    }
	}
	if(iter == interface->get_register_memory_size(REGISTER_RAM))
	    break;
    }
    
    QString invalid("invalid");
    for(int i=16;i<regViewTable->numRows();i++)
    {
	for(int j=0;j<regViewTable->numCols();j++)
	{
	    if(j != 16)
		regViewTable->setText(i,j,invalid);
	    else
		regViewTable->setText(i,j,"................");
	}
    }
}

void MicroSim::viewRegValues_2()
{
    QString register_value;
    QString asciiVal;
    unsigned int iter = 0;
    for(int i=0;i<regViewTable_2->numRows();i++)
    {
	for(int j=0;j<regViewTable_2->numCols();j++)
	{
	    if( (j%16 == 0) && (j != 0) )
	    {
		regViewTable_2->setText(i,j,asciiVal);
		asciiVal = "";
	    }
	    else
	    {
		register_value.sprintf("0x%02x",interface->get_register_value(REGISTER_RAM,iter));
		regViewTable_2->setText(i,j,register_value.ascii());
		char c = (char)interface->get_register_value(REGISTER_RAM,iter++);
		if( (c < ' ') || (c >'z'))
		    asciiVal.append('.');
		else
		    asciiVal.append(c);
	    }
	    
	    if(iter == interface->get_register_memory_size(REGISTER_RAM))
	    {
  regViewTable_2->setText(i,j+1,asciiVal);
  break;
     }
 }
 if(iter == interface->get_register_memory_size(REGISTER_RAM))
     break;
    }
    
    QString invalid("invalid");
    for(int i=16;i<regViewTable_2->numRows();i++)
    {
 for(int j=0;j<regViewTable_2->numCols();j++)
 {
     if(j != 16)
  regViewTable_2->setText(i,j,invalid);
     else
  regViewTable_2->setText(i,j,"................");
 }
    }
}

void MicroSim::viewEEPROMValues()
{
    QString register_value;
    QString asciiVal;
    unsigned int iter = 0;
    for(int i=0;i<regViewTable->numRows();i++)
    {
	for(int j=0;j<regViewTable->numCols();j++)
	{
	    if( (j%16 == 0) && (j != 0) )
	    {
		regViewTable->setText(i,j,asciiVal);
		asciiVal = "";
	    }
	    else
	    {
		register_value.sprintf("0x%02x",interface->get_register_value(REGISTER_EEPROM,iter));
		regViewTable->setText(i,j,register_value.ascii());
		char c = (char)interface->get_register_value(REGISTER_EEPROM,iter++);
		if( (c < ' ') || (c >'z'))
		    asciiVal.append('.');
		else
		    asciiVal.append(c);
	    }
	    
	    if(iter == interface->get_register_memory_size(REGISTER_EEPROM))
	    {
		regViewTable->setText(i,j+1,asciiVal);
		break;
	    }
	}
	if(iter == interface->get_register_memory_size(REGISTER_EEPROM))
	    break;
    }
    
    QString invalid("invalid");
    for(int i=4;i<regViewTable->numRows();i++)
    {
	for(int j=0;j<regViewTable->numCols();j++)
	{
	    if(j != 16)
		regViewTable->setText(i,j,invalid);
	    else
		regViewTable->setText(i,j,"................");
	}
    }
}

void MicroSim::viewEEPROMValues_2()
{
    QString register_value;
    QString asciiVal;
    unsigned int iter = 0;
    for(int i=0;i<regViewTable_2->numRows();i++)
    {
	for(int j=0;j<regViewTable_2->numCols();j++)
	{
	    if( (j%16 == 0) && (j != 0) )
	    {
		regViewTable_2->setText(i,j,asciiVal);
		asciiVal = "";
	    }
	    else
	    {
		register_value.sprintf("0x%02x",interface->get_register_value(REGISTER_EEPROM,iter));
		regViewTable_2->setText(i,j,register_value.ascii());
		char c = (char)interface->get_register_value(REGISTER_EEPROM,iter++);
		if( (c < ' ') || (c >'z'))
		    asciiVal.append('.');
		else
		    asciiVal.append(c);
	    }
	    
	    if(iter == interface->get_register_memory_size(REGISTER_EEPROM))
	    {
		regViewTable_2->setText(i,j+1,asciiVal);
		break;
	    }
	}
	if(iter == interface->get_register_memory_size(REGISTER_EEPROM))
	    break;
    }
    
    QString invalid("invalid");
    for(int i=4;i<regViewTable_2->numRows();i++)
    {
	for(int j=0;j<regViewTable_2->numCols();j++)
	{
	    if(j != 16)
		regViewTable_2->setText(i,j,invalid);
	    else
		regViewTable_2->setText(i,j,"................");
	}
    }
}

void MicroSim::viewProgramMemory()
{
    QString register_value;
    unsigned int iter = 0;
    
    if(!file_is_loaded)
	return;
    
    for(int i=0;i<regViewTable->numRows();i++)
    {
	for(int j=0;j<regViewTable->numCols();j++)
	{
	    if( (j%16 == 0) && (j != 0) )
	    {
		regViewTable->setText(i,j,"");
	    }
	    else
	    {
		register_value.sprintf("0x%02x",interface->get_opcode(iter));
		if(interface->get_opcode(iter++) == 0)
		    regViewTable->setText(i,j,"invalid");
		else
		    regViewTable->setText(i,j,register_value.ascii());
	    }
	    
	    if(iter == interface->get_program_memory_size())
  break;
 }
 
 if(iter == interface->get_program_memory_size())
     break;
    }
}

void MicroSim::viewProgramMemory_2()
{
    QString register_value;
    unsigned int iter = 0;
    
    if(!file_is_loaded)
 return;
    
    for(int i=0;i<regViewTable_2->numRows();i++)
    {
 for(int j=0;j<regViewTable_2->numCols();j++)
 {
     if( (j%16 == 0) && (j != 0) )
     {
  regViewTable_2->setText(i,j,"");
     }
     else
     {
  register_value.sprintf("0x%02x",interface->get_opcode(iter));
  if(interface->get_opcode(iter++) == 0)
      regViewTable_2->setText(i,j,"invalid");
  else
      regViewTable_2->setText(i,j,register_value.ascii());
     }
     
     if(iter == interface->get_program_memory_size())
  break;
 }
 
 if(iter == interface->get_program_memory_size())
     break;
    }
}

void MicroSim::updateRegView(int mode)
{
    switch(mode)
    {
    case 0:
 {
     regEditLabel->setText("Register[      ]:");
     leRegEdit->setText("");
     leRegEdit->setEnabled(false);
     viewNames->setChecked(false);
     viewNames->setEnabled(false);
     viewProgramMemory();
     break; 
 }
    case 1:
 {
     regEditLabel->setText("Register[      ]:");
     leRegEdit->setText("");
     leRegEdit->setEnabled(true);
     viewNames->setEnabled(true);
     viewRegValues();
     break;
 }
    case 2:
 {
     regEditLabel->setText("Register[      ]:");
     leRegEdit->setText("");
     leRegEdit->setEnabled(false);
     viewNames->setChecked(false);
     viewNames->setEnabled(false);
     viewEEPROMValues();
     break;
 }      
    case 3:
 {
     regEditLabel_2->setText("Register[      ]:");
     leRegEdit_2->setText("");
     leRegEdit_2->setEnabled(false);
     viewNames_2->setChecked(false);
     viewNames_2->setEnabled(false);
     viewProgramMemory_2();
     break; 
 }
    case 4:
 {
     regEditLabel_2->setText("Register[      ]:");
     leRegEdit_2->setText("");
     leRegEdit_2->setEnabled(true);
     viewNames_2->setEnabled(true);
     viewRegValues_2();
     break;
 }
    case 5:
 {
     regEditLabel_2->setText("Register[      ]:");
     leRegEdit_2->setText("");
     leRegEdit_2->setEnabled(false);
     viewNames_2->setChecked(false);
     viewNames_2->setEnabled(false);
     viewEEPROMValues_2();
     break;
 }      
    }
}

void MicroSim::viewRegNames(bool flag)
{
    QString register_value;
    int j=0;
    for(unsigned int i=0;i<interface->get_register_memory_size(REGISTER_RAM);i++)
    {
 if( (i%16 == 0) && (i!=0) )
     j++;
 
 if(flag == true)
 {
                  regViewTable->setText(j,i%16,interface->get_register_name(REGISTER_RAM,i));
 }
 else
 {
     register_value.sprintf("0x%02x",interface->get_register_value(REGISTER_RAM,i));
     regViewTable->setText(j,i%16,register_value.ascii());
 }
    }
    leRegEdit->setEnabled(!flag);
}

void MicroSim::viewRegNames_2(bool flag)
{
    QString register_value;
    int j=0;
    for(unsigned int i=0;i<interface->get_register_memory_size(REGISTER_RAM);i++)
    {
 if( (i%16 == 0) && (i!=0) )
     j++;
 
 if(flag == true)
 {
     regViewTable_2->setText(j,i%16,interface->get_register_name(REGISTER_RAM,i));
 }
 else
 {
     register_value.sprintf("0x%02x",interface->get_register_value(REGISTER_RAM,i));
     regViewTable_2->setText(j,i%16,register_value.ascii());
 }
    }
    leRegEdit_2->setEnabled(!flag);
}

void MicroSim::setupRegColors()
{
    QPainter p(regViewTable);
    QColorGroup g;
    g.setColor(QColorGroup::Base,blue);
    regViewTable->paintCell(&p,0,0,regViewTable->cellRect(0,0),false,g);
}

void MicroSim::destroy()
{
    // Delete memory allocations
    
    delete cpu;
    delete interface;
    delete aboutDialog;
    delete pinDialog;
    delete helpBrowser;
    delete runTimer;
    delete timer;
}

void MicroSim::updateSrcPages(bool flag)
{
    int line = interface->get_src_line(interface->get_pc());
    
    
    QListViewItem* newItem = srcPages[0]->firstChild();
    for(int i=1;i<line;i++)
 if(newItem != NULL)
     newItem = newItem->nextSibling();
    if(newItem != NULL)
    {
 newItem->setSelected(flag);
 newItem->repaint();
 srcPages[0]->ensureItemVisible(newItem);
    }    
    
    newItem = srcPages_2[0]->firstChild();
    for(int i=1;i<line;i++)
 if(newItem != NULL)
     newItem = newItem->nextSibling();
    if(newItem != NULL)
    {
 newItem->setSelected(flag);
 newItem->repaint();
 srcPages_2[0]->ensureItemVisible(newItem);
    } 
}

void MicroSim::programStep()
{
    QString pcStr;
    pcStr.sprintf("0x%04x",interface->get_pc());
    QListViewItem* item = opListView->findItem(pcStr,0);
    QListViewItem* item2 = opListView_2->findItem(pcStr,0);
    if(item != NULL && item2 != NULL)
    {
 item->setSelected(false);
 item->repaint();
 item2->setSelected(false);
 item2->repaint();
    }
    const char* instName = item->text(2).ascii();
    addToHistoryList(historyListView,instName);
    addToHistoryList(historyListView_2,instName);
    
    updateSrcPages(false);
    
    interface->step();
    
    loadW_Status_PC();
    
    updateRegisterViewers();
    updateWatchViewer(watchView);
    updateWatchViewer(watchView_2);
    
    pcStr.sprintf("0x%04x",interface->get_pc());
    item = opListView->findItem(pcStr,0);
    item2 = opListView_2->findItem(pcStr,0);
    if(item != NULL && item2 != NULL)
    {
 item->setSelected(true);
 item->repaint();
 item2->setSelected(true);
 item2->repaint();
 opListView->ensureItemVisible(item);
 opListView_2->ensureItemVisible(item2);
    }
    
    if(cpu->simulation_mode == ABNORMAL_STOP && cpu->hm->getWriteMode()!=0)
    {
 cpu->simulation_mode = STOPPED;
 QMessageBox::critical(this, "Error: I/O mode violation", 
         "Changed write modes. Check I/O direction registers. Resetting simulator", 
         QMessageBox::Ok, QMessageBox::NoButton, 
         QMessageBox::NoButton);
 
 showOpen = false;
 fileOpen();
 
    }
    
    updateSrcPages(true);
}

void MicroSim::programRun()
{  
    QString pcStr;
    pcStr.sprintf("0x%04x",interface->get_pc());
    QListViewItem* item = opListView->findItem(pcStr,0);
    QListViewItem* item2 = opListView_2->findItem(pcStr,0);
    if(item != NULL && item2 != NULL)
    {
 item->setSelected(false);
 item->repaint();
 item2->setSelected(false);
 item2->repaint();
    }
    updateSrcPages(false);
    
    disableActions(true);
    menuStopAction->setDisabled(false);
    
    
    //start run processor timer
    runTimer->start(1);
    //thread->start(QThread::TimeCriticalPriority);
    
    
}

void MicroSim::cacheInstruction(char* name)
{
    if(instBuffCount == 30)
 instBuffCount = 0;
    instructionBuffer[instBuffCount++] = name;
}

void MicroSim::startProcessor()
{
    //output a high on pin 16 of LPT
    //char old_ctrl = inb(0x378+2);
    //old_ctrl |= 0x04;
    //outb(old_ctrl,0x378+2);
    cpu->run(instructionRate);
    //after run, set pin 16 to low
    //old_ctrl &= 0xFB;
    //outb(old_ctrl,0x378+2);
}

void MicroSim::programHalt()
{
    runTimer->stop();
    cpu->simulation_mode = STOPPED;
    bp.clear_global();
    loadW_Status_PC();
    QString pcStr;
    pcStr.sprintf("0x%04x",interface->get_pc());
    QListViewItem* item = opListView->findItem(pcStr,0);
    QListViewItem* item2 = opListView_2->findItem(pcStr,0);
    if(item != NULL && item2 != NULL)
    {
 item->setSelected(true);
 item->repaint();
 item2->setSelected(true);
 item2->repaint();
 opListView->ensureItemVisible(item);
 opListView_2->ensureItemVisible(item2);
    }
    updateSrcPages(true);
    
    updateRegisterViewers();
    updateWatchViewer(watchView);
    updateWatchViewer(watchView_2);
    disableActions(false);
    menuStopAction->setDisabled(true);
    updateHistoryLists();
}

void MicroSim::programAlert()
{
    if(cpu->simulation_mode == ABNORMAL_STOP && cpu->hm->getWriteMode()!=0)
    {
 runTimer->stop();
 cpu->simulation_mode = STOPPED;
 QMessageBox::critical(this, "Error: I/O mode violation", 
         "Changed write modes. Check I/O direction registers. Resetting simulator", 
         QMessageBox::Ok, QMessageBox::NoButton, 
         QMessageBox::NoButton);
 showOpen = false;
 fileOpen();     
 updateSrcPages(true);
 disableActions(false);
 menuStopAction->setDisabled(true);
 updateRegisterViewers();
 updateWatchViewer(watchView);
 updateWatchViewer(watchView_2);
 updateHistoryLists();
    }
    
    //updatePinLabels();
}

void MicroSim::updateRegisterViewers()
{
    if(viewNames->isChecked() == false && radioGroup1->selectedId() == 1 )
 viewRegValues();
    else if(radioGroup1->selectedId() == 2)
 viewEEPROMValues();
    
    if(viewNames_2->isChecked() == false && radioGroup2->selectedId() == 4 )
 viewRegValues_2();
    else if(radioGroup2->selectedId() == 5)
 viewEEPROMValues_2();    
}

void MicroSim::disableActions(bool flag)
{
    fileOpenAction->setDisabled(flag);
    menuNextAction->setDisabled(flag);
    menuOverAction->setDisabled(flag);
    menuRunAction->setDisabled(flag);
}

void MicroSim::programStop()
{
    interface->stop();
    runTimer->stop();
    //thread->wait();
    loadW_Status_PC();
    QString pcStr;
    pcStr.sprintf("0x%04x",interface->get_pc());
    QListViewItem* item = opListView->findItem(pcStr,0);
    QListViewItem* item2 = opListView_2->findItem(pcStr,0);
    if(item != NULL && item2 != NULL)
    {
	item->setSelected(true);
	item->repaint();
	item2->setSelected(true);
	item2->repaint();
	opListView->ensureItemVisible(item);
	opListView_2->ensureItemVisible(item2);
    }
    int line = interface->get_src_line(interface->get_pc());
    QListViewItem* newItem = srcPages[0]->firstChild();
    for(int i=1;i<line;i++)
	newItem = newItem->nextSibling();
    newItem->setSelected(true);
    newItem->repaint();
    srcPages[0]->ensureItemVisible(newItem);
    
    updateRegisterViewers();
    
    if(cpu->simulation_mode == ABNORMAL_STOP && cpu->hm->getWriteMode()!=0)
    {
	cpu->simulation_mode = STOPPED;
	QMessageBox::critical(this, "Error: I/O mode violation", 
			      "Changed write modes. Check I/O direction registers. Resetting simulator", 
			      QMessageBox::Ok, QMessageBox::NoButton, 
			      QMessageBox::NoButton);
	showOpen = false;
	fileOpen();
	
    }  
    
    disableActions(false);
    menuStopAction->setDisabled(true);
    updateHistoryLists();
    updatePinLabels();
}


void MicroSim::updatePinLabels()
{
    // Update labels on Hardware Tab
    pinLabel1->setText("<p align=\"center\"><font size=\"5\" color=\"#5555ff\">"+formatPP(1)+"</font></p>");
    pinLabel2->setText("<p align=\"center\"><font size=\"5\" color=\"#5555ff\">"+formatPP(2)+"</font></p>");
    pinLabel3->setText("<p align=\"center\"><font size=\"5\" color=\"#5555ff\">"+formatPP(3)+"</font></p>");
    pinLabel6->setText("<p align=\"center\"><font size=\"5\" color=\"#5555ff\">"+formatPP(6)+"</font></p>");
    pinLabel7->setText("<p align=\"center\"><font size=\"5\" color=\"#5555ff\">"+formatPP(7)+"</font></p>");
    pinLabel8->setText("<p align=\"center\"><font size=\"5\" color=\"#5555ff\">"+formatPP(8)+"</font></p>");
    pinLabel9->setText("<p align=\"center\"><font size=\"5\" color=\"#5555ff\">"+formatPP(9)+"</font></p>");
    pinLabel10->setText("<p align=\"center\"><font size=\"5\" color=\"#5555ff\">"+formatPP(10)+"</font></p>");
    pinLabel11->setText("<p align=\"center\"><font size=\"5\" color=\"#5555ff\">"+formatPP(11)+"</font></p>");
    pinLabel12->setText("<p align=\"center\"><font size=\"5\" color=\"#5555ff\">"+formatPP(12)+"</font></p>");
    pinLabel13->setText("<p align=\"center\"><font size=\"5\" color=\"#5555ff\">"+formatPP(13)+"</font></p>");
    pinLabel17->setText("<p align=\"center\"><font size=\"5\" color=\"#5555ff\">"+formatPP(17)+"</font></p>");
    pinLabel18->setText("<p align=\"center\"><font size=\"5\" color=\"#5555ff\">"+formatPP(18)+"</font></p>");
    
    // Update labels on Workspace Hardware Mapper
    pinLabel1_2->setText("<p align=\"center\"><font color=\"#5555ff\">"+formatPP(1)+"</font></p>");
    pinLabel2_2->setText("<p align=\"center\"><font color=\"#5555ff\">"+formatPP(2)+"</font></p>");
    pinLabel3_2->setText("<p align=\"center\"><font color=\"#5555ff\">"+formatPP(3)+"</font></p>");
    pinLabel6_2->setText("<p align=\"center\"><font color=\"#5555ff\">"+formatPP(6)+"</font></p>");
    pinLabel7_2->setText("<p align=\"center\"><font color=\"#5555ff\">"+formatPP(7)+"</font></p>");
    pinLabel8_2->setText("<p align=\"center\"><font color=\"#5555ff\">"+formatPP(8)+"</font></p>");
    pinLabel9_2->setText("<p align=\"center\"><font color=\"#5555ff\">"+formatPP(9)+"</font></p>");
    pinLabel10_2->setText("<p align=\"center\"><font color=\"#5555ff\">"+formatPP(10)+"</font></p>");
    pinLabel11_2->setText("<p align=\"center\"><font color=\"#5555ff\">"+formatPP(11)+"</font></p>");
    pinLabel12_2->setText("<p align=\"center\"><font color=\"#5555ff\">"+formatPP(12)+"</font></p>");
    pinLabel13_2->setText("<p align=\"center\"><font color=\"#5555ff\">"+formatPP(13)+"</font></p>");
    pinLabel17_2->setText("<p align=\"center\"><font color=\"#5555ff\">"+formatPP(17)+"</font></p>");
    pinLabel18_2->setText("<p align=\"center\"><font color=\"#5555ff\">"+formatPP(18)+"</font></p>");
    
    // Update labels on Hardware Tab
    dirLabel1->setText("<p align=\"center\"><font size=\"5\" color=\"#00aa00\">"+getPinDir(1)+"</font></p>");
    dirLabel2->setText("<p align=\"center\"><font size=\"5\" color=\"#00aa00\">"+getPinDir(2)+"</font></p>");
    dirLabel3->setText("<p align=\"center\"><font size=\"5\" color=\"#00aa00\">"+getPinDir(3)+"</font></p>");
    dirLabel6->setText("<p align=\"center\"><font size=\"5\" color=\"#00aa00\">"+getPinDir(6)+"</font></p>");
    dirLabel7->setText("<p align=\"center\"><font size=\"5\" color=\"#00aa00\">"+getPinDir(7)+"</font></p>");
    dirLabel8->setText("<p align=\"center\"><font size=\"5\" color=\"#00aa00\">"+getPinDir(8)+"</font></p>");
    dirLabel9->setText("<p align=\"center\"><font size=\"5\" color=\"#00aa00\">"+getPinDir(9)+"</font></p>");
    dirLabel10->setText("<p align=\"center\"><font size=\"5\" color=\"#00aa00\">"+getPinDir(10)+"</font></p>");
    dirLabel11->setText("<p align=\"center\"><font size=\"5\" color=\"#00aa00\">"+getPinDir(11)+"</font></p>");
    dirLabel12->setText("<p align=\"center\"><font size=\"5\" color=\"#00aa00\">"+getPinDir(12)+"</font></p>");
    dirLabel13->setText("<p align=\"center\"><font size=\"5\" color=\"#00aa00\">"+getPinDir(13)+"</font></p>");
    dirLabel17->setText("<p align=\"center\"><font size=\"5\" color=\"#00aa00\">"+getPinDir(17)+"</font></p>");
    dirLabel18->setText("<p align=\"center\"><font size=\"5\" color=\"#00aa00\">"+getPinDir(18)+"</font></p>");
    
    // Update labels on Hardware Tab
    stateLabel1->setText("<p align=\"center\"><font size=\"5\" color=\"#ff0000\">"+getPinState(0,2)+"</font></p>");
    stateLabel2->setText("<p align=\"center\"><font size=\"5\" color=\"#ff0000\">"+getPinState(0,3)+"</font></p>");
    stateLabel3->setText("<p align=\"center\"><font size=\"5\" color=\"#ff0000\">"+getPinState(0,4)+"</font></p>");
    stateLabel6->setText("<p align=\"center\"><font size=\"5\" color=\"#ff0000\">"+getPinState(1,0)+"</font></p>");
    stateLabel7->setText("<p align=\"center\"><font size=\"5\" color=\"#ff0000\">"+getPinState(1,1)+"</font></p>");
    stateLabel8->setText("<p align=\"center\"><font size=\"5\" color=\"#ff0000\">"+getPinState(1,2)+"</font></p>");
    stateLabel9->setText("<p align=\"center\"><font size=\"5\" color=\"#ff0000\">"+getPinState(1,3)+"</font></p>");
    stateLabel10->setText("<p align=\"center\"><font size=\"5\" color=\"#ff0000\">"+getPinState(1,4)+"</font></p>");
    stateLabel11->setText("<p align=\"center\"><font size=\"5\" color=\"#ff0000\">"+getPinState(1,5)+"</font></p>");
    stateLabel12->setText("<p align=\"center\"><font size=\"5\" color=\"#ff0000\">"+getPinState(1,6)+"</font></p>");
    stateLabel13->setText("<p align=\"center\"><font size=\"5\" color=\"#ff0000\">"+getPinState(1,7)+"</font></p>");
    stateLabel17->setText("<p align=\"center\"><font size=\"5\" color=\"#ff0000\">"+getPinState(0,0)+"</font></p>");
    stateLabel18->setText("<p align=\"center\"><font size=\"5\" color=\"#ff0000\">"+getPinState(0,1)+"</font></p>");
    
    
    for(int i=1; i<=18; i++)
    {
	if(cpu->hm->getPortPin(i)==-1 && comboArray[i] != NULL)
	{
	    comboArray[i]->setCurrentItem(0);
	}
    }
    
}

void MicroSim::changeCombo1()
{
    cpu->hm->mapPin(1, comboArray[1]->currentText().section(' ',0,0).toInt());
    updatePinLabels();
}

void MicroSim::changeCombo2()
{
    cpu->hm->mapPin(2, comboArray[2]->currentText().section(' ',0,0).toInt());
    updatePinLabels();
}

void MicroSim::changeCombo3()
{
    cpu->hm->mapPin(3, comboArray[3]->currentText().section(' ',0,0).toInt());
    updatePinLabels();
}

void MicroSim::changeCombo6()
{
    cpu->hm->mapPin(6, comboArray[6]->currentText().section(' ',0,0).toInt());
    updatePinLabels();
}

void MicroSim::changeCombo7()
{
    cpu->hm->mapPin(7, comboArray[7]->currentText().section(' ',0,0).toInt());
    updatePinLabels();
}

void MicroSim::changeCombo8()
{
    cpu->hm->mapPin(8, comboArray[8]->currentText().section(' ',0,0).toInt());
    updatePinLabels();
}

void MicroSim::changeCombo9()
{
    cpu->hm->mapPin(9, comboArray[9]->currentText().section(' ',0,0).toInt());
    updatePinLabels();
}

void MicroSim::changeCombo10()
{
    cpu->hm->mapPin(10, comboArray[10]->currentText().section(' ',0,0).toInt());
    updatePinLabels();
}


void MicroSim::changeCombo11()
{
    cpu->hm->mapPin(11, comboArray[11]->currentText().section(' ',0,0).toInt());
    updatePinLabels();
}

void MicroSim::changeCombo12()
{
    cpu->hm->mapPin(12, comboArray[12]->currentText().section(' ',0,0).toInt());
    updatePinLabels();
}

void MicroSim::changeCombo13()
{
    cpu->hm->mapPin(13, comboArray[13]->currentText().section(' ',0,0).toInt());
    updatePinLabels();
}

void MicroSim::changeCombo17()
{
    cpu->hm->mapPin(17, comboArray[17]->currentText().section(' ',0,0).toInt());
    updatePinLabels();
}

void MicroSim::changeCombo18()
{
    cpu->hm->mapPin(18, comboArray[18]->currentText().section(' ',0,0).toInt());
    updatePinLabels();
}


QString MicroSim::formatPP(int PICpin)
{
    int temp = cpu->hm->getPortPin(PICpin);
    if(temp==-1)
	return QString("X");
    else
 return QString::number(temp);
}

QString MicroSim::getPinDir(int PICpin)
{
    int temp = cpu->hm->getIOStatus(PICpin-1);
    if(temp == 0)
 return QString("Out");
    else if(temp == 1)
 return QString("In");
    else
 return QString("X");
}

QString MicroSim::getPinState(int port, int bit)
{
    // Port A 
    int temp = 0;
    if(port == 0)
	temp = cpu->porta->get_bit(bit);
    else if(port == 1)
	temp = cpu->portb->get_bit(bit);
    
    if(temp == 0)
	return QString("Low");
    else if(temp == 1)
	return QString("High");
    
    return QString("");
    
}

void MicroSim::printPins()
{
    cout<<endl;
    for(int i=1;i<=18;i++)
	cout<<"PIC Pin: "<<i<<" = Port Pin: "<<cpu->hm->getPortPin(i)<<endl;
}


void MicroSim::initAddToWatch()
{
    int row = regViewTable->currentRow();
    int col = regViewTable->currentColumn();
    addToWatch(row,col);
}

void MicroSim::initAddToWatch_2()
{
    int row = regViewTable_2->currentRow();
    int col = regViewTable_2->currentColumn();
    addToWatch(row,col);
}

void MicroSim::addToWatch(int row, int col)
{
    QHeader* horiz = regViewTable->horizontalHeader();
    QHeader* vertic = regViewTable->verticalHeader();
    
    QString lowNibble = horiz->label(col);
    QString hiNibble = vertic->label(row);
    
    bool ok;
    int addr = hiNibble.toInt(&ok,16) + lowNibble.toInt(&ok,16);
    Register* regToAdd;
    WatchRegister* watchReg;
    if(radioGroup1->selectedId() == 1)
    {
 regToAdd = interface->get_register_ref(REGISTER_RAM,addr);
 watchReg = new WatchRegister(regToAdd,REGISTER_RAM);
    }
    else if(radioGroup1->selectedId() == 2)
    {
	regToAdd = interface->get_register_ref(REGISTER_EEPROM,addr);
	watchReg = new WatchRegister(regToAdd,REGISTER_EEPROM);
    }
    
    watchRegisters.push_back(*watchReg);
    updateWatchViewer(watchView);
    updateWatchViewer(watchView_2);
    
}

void MicroSim::removeWatchReg(QListViewItem* item,const QPoint& p,int col)
{   
    if(item != NULL)
    {
	QString typeStr = item->text(2);
	QString addrStr = item->text(3);
	vector<WatchRegister>::iterator it;
	for(it=watchRegisters.begin();it!=watchRegisters.end();it++)
	{
	    if( ((*it).type() == typeStr) && ((*it).addr() == addrStr) )
	    {
		watchRegisters.erase(it);
		break;
	    }
	}
	updateWatchViewer(watchView);
	updateWatchViewer(watchView_2);
    }
}

void MicroSim::updateWatchViewer(QListView* listView)
{
    listView->clear();
    vector<WatchRegister>::iterator it = watchRegisters.begin();
    if(watchRegisters.size() > 0)
    {
	(*it).updateFields();
	QListViewItem* item = new QListViewItem(listView,(*it).name(),(*it).bp(),(*it).type(),(*it).addr(),(*it).dec(),(*it).hex(),(*it).ascii(),(*it).bin());
	QListViewItem* temp;
	it++;
	for(;it!=watchRegisters.end();it++)
	{
	    (*it).updateFields();
	    temp = new QListViewItem(listView,item,(*it).name(),(*it).bp(),(*it).type()            ,(*it).addr(),(*it).dec(),(*it).hex(),(*it).ascii(),(*it).bin());
	    item = temp;
	}   
    }
}

void MicroSim::watchRegister(int row, int col, int button, const QPoint & mousePos)
{
    if(button == Qt::RightButton && 
       (radioGroup1->selectedId() == 1 || radioGroup1->selectedId() == 2) && col < 16 && file_is_loaded)
    {
 QPopupMenu popup;
 popup.insertItem("Add To Watch",this,SLOT(initAddToWatch()));
 popup.insertItem("Toggle Read Break",this,SLOT(initReadBreak()));
 popup.insertItem("Toggle Write Break",this,SLOT(initWriteBreak()));
 popup.exec(QCursor::pos());
    }
}

void MicroSim::watchRegister_2(int row, int col, int button, const QPoint & mousePos)
{
    if(button == Qt::RightButton && 
       (radioGroup2->selectedId() == 4 || radioGroup2->selectedId() == 5) && col < 16 && file_is_loaded)
    {
 QPopupMenu popup;
 popup.insertItem("Add To Watch",this,SLOT(initAddToWatch_2()));
	popup.insertItem("Toggle Read Break",this,SLOT(initReadBreak_2()));
	popup.insertItem("Toggle Write Break",this,SLOT(initWriteBreak_2()));
	popup.exec(QCursor::pos());
    }
}

void MicroSim::initReadBreak()
{
    int row = regViewTable->currentRow();
    int col = regViewTable->currentColumn();
    QHeader* horiz = regViewTable->horizontalHeader();
    QHeader* vertic = regViewTable->verticalHeader();
    
    QString lowNibble = horiz->label(col);
    QString hiNibble = vertic->label(row);
    
    bool ok;
    unsigned int addr = hiNibble.toInt(&ok,16) + lowNibble.toInt(&ok,16);
    if(cpu->rma.hasBreak(addr) == true)
    {      
 interface->toggle_read_break_at_address(addr);
 toggleReadBreak(regViewTable,row,col,false);
 toggleReadBreak(regViewTable_2,row,col,false);
    }
    else
    {
 interface->toggle_read_break_at_address(addr);
 toggleReadBreak(regViewTable,row,col,true);
 toggleReadBreak(regViewTable_2,row,col,true);
    }
}

void MicroSim::initReadBreak_2()
{
    int row = regViewTable_2->currentRow();
    int col = regViewTable_2->currentColumn();
    QHeader* horiz = regViewTable_2->horizontalHeader();
    QHeader* vertic = regViewTable_2->verticalHeader();
    
    QString lowNibble = horiz->label(col);
    QString hiNibble = vertic->label(row);
    
    bool ok;
    unsigned int addr = hiNibble.toInt(&ok,16) + lowNibble.toInt(&ok,16);
    if(cpu->rma.hasBreak(addr) == true)
    {      
	interface->toggle_read_break_at_address(addr);
	toggleReadBreak(regViewTable,row,col,false);
	toggleReadBreak(regViewTable_2,row,col,false);
    }
    else
    {
	interface->toggle_read_break_at_address(addr);
	toggleReadBreak(regViewTable,row,col,true);
	toggleReadBreak(regViewTable_2,row,col,true);
    }
}

void MicroSim::toggleReadBreak(QTable* table, int row, int col, bool flag)
{
    ColorTableItem *cti;
    if(flag == true)
	cti = new ColorTableItem(table,QTableItem::OnTyping,table->text(row,col),READ_BREAK);
    else
	cti = new ColorTableItem(table,QTableItem::OnTyping,table->text(row,col),NO_BREAK);
    table->takeItem(table->item(row,col));
    table->setItem(row,col,cti);
    table->updateCell(row,col);
}

void MicroSim::initWriteBreak()
{
    int row = regViewTable->currentRow();
    int col = regViewTable->currentColumn();
    QHeader* horiz = regViewTable->horizontalHeader();
    QHeader* vertic = regViewTable->verticalHeader();
    
    QString lowNibble = horiz->label(col);
    QString hiNibble = vertic->label(row);
    
    bool ok;
    unsigned int addr = hiNibble.toInt(&ok,16) + lowNibble.toInt(&ok,16);
    if(cpu->rma.hasBreak(addr) == true)
    {      
	interface->toggle_write_break_at_address(addr);
	toggleWriteBreak(regViewTable,row,col,false);
	toggleWriteBreak(regViewTable_2,row,col,false);
    }
    else
    {
 interface->toggle_write_break_at_address(addr);
 toggleWriteBreak(regViewTable,row,col,true);
 toggleWriteBreak(regViewTable_2,row,col,true);
    }
}

void MicroSim::initWriteBreak_2()
{
    int row = regViewTable_2->currentRow();
    int col = regViewTable_2->currentColumn();
    QHeader* horiz = regViewTable_2->horizontalHeader();
    QHeader* vertic = regViewTable_2->verticalHeader();
    
    QString lowNibble = horiz->label(col);
    QString hiNibble = vertic->label(row);
    
    bool ok;
    unsigned int addr = hiNibble.toInt(&ok,16) + lowNibble.toInt(&ok,16);
    if(cpu->rma.hasBreak(addr) == true)
    {      
	interface->toggle_write_break_at_address(addr);
	toggleWriteBreak(regViewTable,row,col,false);
	toggleWriteBreak(regViewTable_2,row,col,false);
    }
    else
    {
	interface->toggle_write_break_at_address(addr);
	toggleWriteBreak(regViewTable,row,col,true);
	toggleWriteBreak(regViewTable_2,row,col,true);
    }
}

void MicroSim::toggleWriteBreak(QTable* table, int row, int col, bool flag)
{
    ColorTableItem *cti;
    if(flag == true)
	cti = new ColorTableItem(table,QTableItem::OnTyping,table->text(row,col),WRITE_BREAK);
    else
	cti = new ColorTableItem(table,QTableItem::OnTyping,table->text(row,col),NO_BREAK);
    table->takeItem(table->item(row,col));
    table->setItem(row,col,cti);
    table->updateCell(row,col);
}

void MicroSim::clearBPFromRegViews()
{
    for(int i=0;i<regViewTable->numRows();i++)
    {
	for(int j=0;j<regViewTable->numCols();j++)
	{
     QTableItem *item = regViewTable->item(i,j);
     QTableItem *item2 = regViewTable_2->item(i,j);
     if(typeid(*item) == typeid(ColorTableItem))
     {
  ColorTableItem *cti = (ColorTableItem*)item;
  ColorTableItem *cti2 = (ColorTableItem*)item2;
  cti->setType(NO_BREAK);
  cti2->setType(NO_BREAK);
  regViewTable->updateCell(i,j); 
  regViewTable_2->updateCell(i,j); 
     }
 }
    }
}

void MicroSim::clearBPFromSource()
{
    QListViewItem *item = srcPages[0]->firstChild();
    item->setText(0,"");
    do
    {
 item = item->itemBelow();
 item->setText(0,"");
    }while(item != srcPages[0]->lastItem());
    
    item = srcPages_2[0]->firstChild();
    do
    {
 item = item->itemBelow();
 item->setText(0,"");
    }
    while(item != srcPages_2[0]->lastItem());
}

void MicroSim::clearAllRegBP()
{
    for(unsigned int i=0;i<cpu->register_memory_size();i++)   
 bp.clear_all_register(cpu,i);
    clearBPFromRegViews();
}

void MicroSim::clearAllBP()
{
    bp.clear_all(cpu);
    clearBPFromRegViews();
    clearBPFromSource();
}

void MicroSim::setOpFreq(int index)
{
    if(index == 0)
        instructionRate = 8;
    else if(index == 1)
        instructionRate = 250;
    else if(index == 2)
        instructionRate = 1000;
    else if(index == 3)
        instructionRate = 2500;
    else if(index == 4)
        instructionRate = 5000;
}
        
void MicroSim::updateParallelPortAddress(int id)
{
    cpu->hm->setLptData(id);     
}
