#ifndef WDT_H
#define WDT_H

#include "breakpoints.h"
//#include "processor.h"

class Processor;

//---------------------------------------------------------
// Watch Dog Timer
//
//HOW TO IMPLEMENT

//! \class
/*!
    \brief Watch Dog Timer
*/
class WDT : public BreakCallBack 
{
public:
  //! The cpu to which this WDT belongs
  Processor *cpu;           

  //! Value
  unsigned int value;
  //! Prescale
  unsigned int prescale;
  //! Break point
  unsigned int break_point;
  //! Future cycle
  guint64 future_cycle;

  //! Timeout when no prescaler is assigned
  double timeout;  
  //! WDTE 
  bool   wdte;
  //! Warned
  bool   warned;

  //! Put new value
  /*!
      \param new_value New value
  */
  void put(unsigned int new_value);
  //! Initialize
  /*!
      \param enable Enable WDT
      \param _timeout Timeout period
  */
  virtual void initialize(bool enable, double _timeout);
  //! Clears the WDT
  void clear(void);
  //! Callback
  virtual void callback(void);
  //! Start Sleep
  virtual void start_sleep(void);
  //! New Prescale
  virtual void new_prescale(void);
  //! Updates WDT
  virtual void update(void);
  //! Prints callback
  virtual void callback_print(void);
};

#endif
